package Comm::BuddyList;

sub new {
  my $ref = shift;
  my $class = ref( $class ) || $class;

  my %data = (
    gui => undef,
    users => (),
    log => undef,
    @_
  );

  die "Please provide a reference to the GUI table" unless ( $data{ table } );
  die "Please provide a list of users for the Buddy List" unless ( $data{ users } );

  die "Invalid GUI object in new" unless ( ref( $data{ gui } ) eq 'GUI::BuddyList' );

  my $self = bless %data, $class;

  $self->updateUser( @{ $data{ users } } );

  return $self;
}

sub addUser {
  my ( $self, @users ) = @_;

  foreach ( @users ) {
    die "Invalid user object in addUser" unless ( ref( $_ ) eq 'Comm::User' );
    $self->{ users }{ "$_" } = $_;
    $self->logChange( action => 'add', user => "$_" );
  }

}

sub removeUser {
  my ( $self, @users ) = @_;

  foreach ( @users ) {
    die "Invalid user object in addUser" unless ( ref( $_ ) eq 'Comm::User' );
    die "User does not exist" unless ( exists $self->{ users }{ "$_" } );
    delete $self->{ users }{ "$_" };
    $self->logChange( action => 'remove', user => "$_" );
  }
}

sub updateUser {
  my ( $self, @users ) = @_;

  foreach ( @users ) {
    die "Invalid user object in addUser" unless ( ref( $_ ) eq 'Comm::User' );
    $self->{ users }{ "$_" } = $_;
    $self->logChange( action => 'update', user => "$_" );
  }
}

sub logChange {
  my ( %action ) = @_;

  unless ( $self->{ log } ) {
    

  }
}
1;
